> ## Documentation Index
> Fetch the complete documentation index at: https://www.latitude.sh/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create user data

> Allows you to create User Data in a team, which can be used to perform custom setup on your servers after deploy and reinstall.




## OpenAPI

````yaml https://spec.speakeasy.com/latitude/latitude/latitude-sh-api-with-code-samples post /user_data
openapi: 3.0.1
info:
  title: Latitude.sh API
  version: '2023-06-01'
  description: >-
    The Latitude.sh API is a RESTful API to manage your Latitude.sh account. It
    allows you to perform the same actions as the Latitude.sh dashboard.
servers:
  - url: https://api.latitude.sh
    variables:
      latitude_api_key:
        default: <insert your api key here>
  - url: http://api.latitude.sh
    variables:
      latitude_api_key:
        default: <insert your api key here>
security: []
tags:
  - name: API keys
  - name: Billing
  - name: Elastic Ips
  - name: Events
  - name: Firewalls
  - name: IP Addresses
  - name: Kubernetes Clusters
  - name: Operating Systems
  - name: Plans
  - name: Private Networks
  - name: Projects
  - name: Regions
  - name: Roles
  - name: SSH Keys
  - name: Servers
  - name: Storage
  - name: Tags
  - name: Teams
  - name: Team members
  - name: Traffic
  - name: User data
  - name: User profile
  - name: VPN Sessions
  - name: Virtual machines
paths:
  /user_data:
    post:
      tags:
        - User data
      summary: Create user data
      description: >
        Allows you to create User Data in a team, which can be used to perform
        custom setup on your servers after deploy and reinstall.
      operationId: post-user-data
      parameters: []
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                data:
                  type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - user_data
                    attributes:
                      type: object
                      properties:
                        description:
                          type: string
                          description: description of the User Data
                        project:
                          type: string
                          description: Project ID or slug
                        content:
                          type: string
                          description: base64 encoded content of the User Data
                      required:
                        - content
                        - description
                  required:
                    - type
              required:
                - data
            examples:
              Created:
                summary: Created
                value:
                  data:
                    type: user_data
                    attributes:
                      content: >-
                        I2Nsb3VkLWNvbmZpZwpydW5jbWQ6CiAtIFsgdG91Y2gsICAvaG9tZS91YnVudHUvdGVzdCBd
                      description: User Data description
                      project: proj_QraYDPW3qpjwW
          application/vnd.api+json:
            schema:
              type: object
              properties:
                data:
                  type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - user_data
                    attributes:
                      type: object
                      properties:
                        description:
                          type: string
                          description: description of the User Data
                        project:
                          type: string
                          description: Project ID or slug
                        content:
                          type: string
                          description: base64 encoded content of the User Data
                      required:
                        - content
                        - description
                  required:
                    - type
              required:
                - data
            examples:
              Created:
                summary: Created
                value:
                  data:
                    type: user_data
                    attributes:
                      content: >-
                        I2Nsb3VkLWNvbmZpZwpydW5jbWQ6CiAtIFsgdG91Y2gsICAvaG9tZS91YnVudHUvdGVzdCBd
                      description: User Data description
                      project: proj_QraYDPW3qpjwW
        required: true
      responses:
        '201':
          description: Created
          content:
            application/vnd.api+json:
              examples:
                Created:
                  value:
                    data:
                      id: ud_w49QDB55qagKb
                      type: user_data
                      attributes:
                        description: User Data description
                        content: >-
                          I2Nsb3VkLWNvbmZpZwpydW5jbWQ6CiAtIFsgdG91Y2gsICAvaG9tZS91YnVudHUvdGVzdCBd
                        created_at: '2026-01-14T15:57:11+00:00'
                        updated_at: '2026-01-14T15:57:11+00:00'
                        decoded_content: |-
                          #cloud-config
                          runcmd:
                           - [ touch,  /home/ubuntu/test ]
                        project:
                          id: proj_QraYDPW3qpjwW
                          name: Rustic Granite Gloves
                          slug: rustic-granite-gloves
                          description: Heavy Duty Leather Wallet
                          provisioning_type: on_demand
                          billing_type: Normal
                          billing_method: Normal
                          bandwidth_alert: false
                          environment: null
                          billing: {}
                          stats:
                            databases: 0
                            ip_addresses: 0
                            prefixes: 0
                            servers: 0
                            storages: 0
                            virtual_machines: 0
                            vlans: 0
                    meta: {}
              schema:
                $ref: '#/components/schemas/user_data_object'
      security:
        - Bearer: []
      x-codeSamples:
        - lang: python
          label: Python (SDK)
          source: |-
            import latitudesh_python_sdk
            from latitudesh_python_sdk import Latitudesh
            import os


            with Latitudesh(
                bearer=os.getenv("LATITUDESH_BEARER", ""),
            ) as latitudesh:

                res = latitudesh.user_data.post_user_data(data={
                    "type": latitudesh_python_sdk.PostUserDataUserDataType.USER_DATA,
                    "attributes": {
                        "description": "User Data description",
                        "project": "proj_QraYDPW3qpjwW",
                        "content": "I2Nsb3VkLWNvbmZpZwpydW5jbWQ6CiAtIFsgdG91Y2gsICAvaG9tZS91YnVudHUvdGVzdCBd",
                    },
                })

                # Handle response
                print(res)
        - lang: go
          label: Go (SDK)
          source: "package main\n\nimport(\n\t\"context\"\n\t\"os\"\n\tlatitudeshgosdk \"github.com/latitudesh/latitudesh-go-sdk\"\n\t\"github.com/latitudesh/latitudesh-go-sdk/models/operations\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := latitudeshgosdk.New(\n        latitudeshgosdk.WithSecurity(os.Getenv(\"LATITUDESH_BEARER\")),\n    )\n\n    res, err := s.UserData.CreateNew(ctx, operations.PostUserDataUserDataRequestBody{\n        Data: operations.PostUserDataUserDataData{\n            Type: operations.PostUserDataUserDataTypeUserData,\n            Attributes: &operations.PostUserDataUserDataAttributes{\n                Description: \"User Data description\",\n                Project: latitudeshgosdk.Pointer(\"proj_QraYDPW3qpjwW\"),\n                Content: \"I2Nsb3VkLWNvbmZpZwpydW5jbWQ6CiAtIFsgdG91Y2gsICAvaG9tZS91YnVudHUvdGVzdCBd\",\n            },\n        },\n    })\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.UserDataObject != nil {\n        // handle response\n    }\n}"
        - lang: typescript
          label: Typescript (SDK)
          source: |-
            import { Latitudesh } from "latitudesh-typescript-sdk";

            const latitudesh = new Latitudesh({
              bearer: process.env["LATITUDESH_BEARER"] ?? "",
            });

            async function run() {
              const result = await latitudesh.userData.createNew({
                data: {
                  type: "user_data",
                  attributes: {
                    description: "User Data description",
                    project: "proj_QraYDPW3qpjwW",
                    content: "I2Nsb3VkLWNvbmZpZwpydW5jbWQ6CiAtIFsgdG91Y2gsICAvaG9tZS91YnVudHUvdGVzdCBd",
                  },
                },
              });

              console.log(result);
            }

            run();
components:
  schemas:
    user_data_object:
      type: object
      properties:
        data:
          $ref: '#/components/schemas/user_data_properties'
        meta:
          type: object
    user_data_properties:
      type: object
      properties:
        id:
          type: string
        type:
          type: string
          enum:
            - user_data
        attributes:
          type: object
          properties:
            description:
              type: string
              description: description of the User Data
            content:
              type: string
              description: content of the User Data
            project:
              $ref: '#/components/schemas/project_include'
            created_at:
              type: string
            updated_at:
              type: string
      required:
        - type
    project_include:
      type: object
      properties:
        id:
          type: string
        name:
          type: string
        slug:
          type: string
        description:
          type: string
          nullable: true
        billing_type:
          type: string
          nullable: true
        provisioning_type:
          type: string
          nullable: true
        billing_method:
          type: string
          nullable: true
        bandwidth_alert:
          type: boolean
        environment:
          type: string
          nullable: true
        billing:
          type: object
          properties:
            subscription_id:
              type: string
              nullable: true
            type:
              type: string
            method:
              type: string
        stats:
          type: object
          properties:
            ip_addresses:
              type: integer
            prefixes:
              type: integer
            servers:
              type: integer
            vlans:
              type: integer
  securitySchemes:
    Bearer:
      type: apiKey
      name: Authorization
      in: header

````